local e=require"nixio.fs"
local d=e.access("/proc/net/ipv6_route")
m=Map("ocserv",translate("OpenConnect VPN"))
s=m:section(TypedSection,"ocserv","OpenConnect")
s.anonymous=true
s:tab("general",translate("General Settings"))
s:tab("ca",translate("CA certificate"))
s:tab("template",translate("Edit Template"))
local n=s:taboption("general",Flag,"enable",translate("Enable server"))
n.rmempty=false
n.default="1"
local r=s:taboption("general",DummyValue,"sha_hash",translate("Server's certificate SHA1 hash"),
translate("That value should be communicated to the client to verify the server's certificate"))
local h=s:taboption("general",DummyValue,"pkid",translate("Server's Public Key ID"),
translate("An alternative value to be communicated to the client to verify the server's certificate; this value only depends on the public key"))
local a=io.popen("/usr/bin/certtool -i --infile /etc/ocserv/server-cert.pem","r")
if a then local e
local i=false
local o=false
local e=0
while e<2 do
local t=a:read("*l")
if not t then
break
elseif t:match("SHA%-?1 fingerprint:")then
i=true
elseif i then
local t=t:match("([a-f0-9]+)")
r.default=t and t:upper()
e=e+1
i=false
elseif t:match("Public Key I[Dd]:")then
o=true
elseif o then
local t=t:match("([a-f0-9]+)")
h.default=t and"sha1:"..t:upper()
e=e+1
o=false
end
end
a:close()
end
function m.on_commit(e)
luci.sys.call("/usr/bin/occtl reload  >/dev/null 2>&1")
end
function n.write(t,a,e)
if e=="0"then
luci.sys.call("/etc/init.d/ocserv stop >/dev/null 2>&1")
luci.sys.call("/etc/init.d/ocserv disable  >/dev/null 2>&1")
else
luci.sys.call("/etc/init.d/ocserv enable  >/dev/null 2>&1")
luci.sys.call("/etc/init.d/ocserv restart  >/dev/null 2>&1")
end
Flag.write(t,a,e)
end
local e
e=s:taboption("general",ListValue,"auth",translate("User Authentication"),
translate("The authentication method for the users. The simplest is plain with a single username-password pair. Use PAM modules to authenticate using another server (e.g., LDAP, Radius)."))
e.rmempty=false
e.default="plain"
e:value("plain")
e:value("PAM")
e=s:taboption("general",Value,"zone",translate("Firewall Zone"),
translate("The firewall zone that the VPN clients will be set to"))
e.nocreate=true
e.default="lan"
e.template="cbi/firewall_zonelist"
s:taboption("general",Value,"port",translate("Port"),
translate("The same UDP and TCP ports will be used"))
s:taboption("general",Value,"max_clients",translate("Max clients"))
s:taboption("general",Value,"max_same",translate("Max same clients"))
s:taboption("general",Value,"dpd",translate("Dead peer detection time (secs)"))
local t=s:taboption("general",Flag,"predictable_ips",translate("Predictable IPs"),
translate("The assigned IPs will be selected deterministically"))
t.default="1"
local t=s:taboption("general",Flag,"compression",translate("Enable compression"),
translate("Enable compression"))
t.default="1"
local t=s:taboption("general",Flag,"udp",translate("Enable UDP"),
translate("Enable UDP channel support; this must be enabled unless you know what you are doing"))
t.default="1"
local t=s:taboption("general",Flag,"cisco_compat",translate("AnyConnect client compatibility"),
translate("Enable support for CISCO AnyConnect clients"))
t.default="1"
ipaddr=s:taboption("general",Value,"ipaddr",translate("VPN <abbr title=\"Internet Protocol Version 4\">IPv4</abbr>-Network-Address"))
ipaddr.datatype="ip4addr"
ipaddr.default="192.168.100.1"
nm=s:taboption("general",Value,"netmask",translate("VPN <abbr title=\"Internet Protocol Version 4\">IPv4</abbr>-Netmask"))
nm.datatype="ip4addr"
nm.default="255.255.255.0"
nm:value("255.255.255.0")
nm:value("255.255.0.0")
nm:value("255.0.0.0")
if d then
ip6addr=s:taboption("general",Value,"ip6addr",translate("VPN <abbr title=\"Internet Protocol Version 6\">IPv6</abbr>-Network-Address"),translate("<abbr title=\"Classless Inter-Domain Routing\">CIDR</abbr>-Notation: address/prefix"))
ip6addr.datatype="ip6addr"
end
tmpl=s:taboption("template",Value,"_tmpl",
translate("Edit the template that is used for generating the ocserv configuration."))
tmpl.template="cbi/tvalue"
tmpl.rows=20
function tmpl.cfgvalue(e,e)
return nixio.fs.readfile("/etc/ocserv/ocserv.conf.template")
end
function tmpl.write(t,t,e)
e=e:gsub("\r\n?","\n")
nixio.fs.writefile("/etc/ocserv/ocserv.conf.template",e)
end
ca=s:taboption("ca",Value,"_ca",
translate("View the CA certificate used by this server. You will need to save it as 'ca.pem' and import it into the clients."))
ca.template="cbi/tvalue"
ca.rows=20
function ca.cfgvalue(e,e)
return nixio.fs.readfile("/etc/ocserv/ca.pem")
end
s=m:section(TypedSection,"dns",translate("DNS servers"),
translate("The DNS servers to be provided to clients; can be either IPv6 or IPv4"))
s.anonymous=true
s.addremove=true
s.template="cbi/tblsection"
s:option(Value,"ip",translate("IP Address")).rmempty=true
s.datatype="ipaddr"
s=m:section(TypedSection,"routes",translate("Routing table"),
translate("The routing table to be provided to clients; you can mix IPv4 and IPv6 routes, the server will send only the appropriate. Leave empty to set a default route"))
s.anonymous=true
s.addremove=true
s.template="cbi/tblsection"
s:option(Value,"ip",translate("IP Address")).rmempty=true
e=s:option(Value,"netmask",translate("Netmask (or IPv6-prefix)"))
e.default="255.255.255.0"
e:value("255.255.255.0")
e:value("255.255.0.0")
e:value("255.0.0.0")
return m
